from collections import defaultdict

def main():
    # Wczytujemy opis.
    opis = input()

    # Początkowe współrzędne ustalamy na (0,0).
    x, y = 0, 0

    # Trzymamy mapę odcinków pionowych, gdzie kluczem jest współrzędna y,
    # a wartościami są współrzędne x (konkretniej oznacza ona odcinek od (x,y) do
    # (x,y+1)). Struktura defaultdict automatycznie inicjalizuje listy.
    odcinki_pionowe = defaultdict(list)

    for litera in opis:
        if litera == "G":
            # Dla ruchu w górę, dodajemy odcinek (x, y) do (x, y+1).
            odcinki_pionowe[y].append(x)
            # Przesuwamy współrzędną y o 1 w górę.
            y += 1
        elif litera == "D":
            # Dla ruchu w dół, dodajemy odcinek (x, y-1) do (x, y).
            odcinki_pionowe[y - 1].append(x)
            # Przesuwamy współrzędną y o 1 w dół.
            y -= 1
        elif litera == "P":
            # Dla ruchu w prawo, modyfikujemy współrzędną x.
            x += 1
        elif litera == "L":
            # Dla ruchu w lewo, modyfikujemy współrzędną x.
            x -= 1

    # Finalnie liczymy pole figury.
    pole = 0

    # Iterujemy po wszystkich współrzędnych y, które zapisaliśmy.
    for y, odcinki in odcinki_pionowe.items():
        # Sortujemy listę odcinków.
        odcinki.sort()
        # Dodajemy odległość pomiędzy odcinkiem otwierającym (odcinki[i])
        # i zamykającym figurę (odcinki[i+1]).
        for i in range(0, len(odcinki), 2):
            pole += odcinki[i + 1] - odcinki[i]

    # Finalnie wypisujemy wynik.
    print(pole)


if __name__ == "__main__":
    main()
